if select(2, UnitClass("player")) ~= "DEATHKNIGHT" then return end
local GT = LibStub:GetLibrary("LibGratuity-3.0")
local GetSpellInfo = GetSpellInfo
local IsEquippedItem = IsEquippedItem
local select = select
local UnitPower = UnitPower
local UnitHealthMax = UnitHealthMax

function DrDamage:PlayerData()

	--Special Calculation
	self.Calculation["Attack"] = function ( calculation, _, BuffTalentRanks )
		if BuffTalentRanks["Necrosis"] then
			calculation.dmgM = calculation.dmgM * ( 1 + BuffTalentRanks["Necrosis"] )
		end
	end
	
	self.Calculation["Two-Handed Weapon Specialization"] = function( calculation, value )
		if self:GetNormM() == 3.3 then
			if calculation.wDmgM then
				calculation.wDmgM = calculation.wDmgM * (1 + value)
			else
				calculation.dmgM = calculation.dmgM * (1 + value)
			end
		end
	end
	
	--General
	self.Calculation["DEATHKNIGHT"] = function( calculation, ActiveAuras, BuffTalentRanks, spell, baseSpell )
		--General
		calculation.spellDmgM = 0
	
		if not baseSpell.Melee then
			if baseSpell.SpellAPBonus then
				calculation.AP = self:GetAP()
				calculation.minDam = calculation.minDam + calculation.AP * baseSpell.SpellAPBonus * (1 + (BuffTalentRanks["Impurity"] or 0))
				calculation.maxDam = calculation.maxDam + calculation.AP * baseSpell.SpellAPBonus * (1 + (BuffTalentRanks["Impurity"] or 0))
			end
		end
        
		--Ebon Plague magic buff
		if BuffTalentRanks["Ebon Plaguebringer"] and ActiveAuras["Ebon Plague"] then
			if baseSpell.School == "Shadow" or baseSpell.School == "Frost" then
				calculation.dmgM = calculation.dmgM * (1 + BuffTalentRanks["Ebon Plaguebringer"])
			end
		end
		if BuffTalentRanks["Tundra Stalker"] and ActiveAuras["Frost Fever"] then
			calculation.dmgM = calculation.dmgM + (1 * BuffTalentRanks["Tundra Stalker"])
		end
		if BuffTalentRanks["Rage of Rivendare"] and ActiveAuras["Blood Plague"]  then
			calculation.dmgM = calculation.dmgM + (1 * BuffTalentRanks["Rage of Rivendare"])
		end	
	end
	
	--Spell Specific
	self.Calculation["Blood Strike"] = function( calculation, _, _, _, baseSpell )
		calculation.dmgM = calculation.dmgM * (1 + self.diseaseCount * baseSpell.bonusPercent * ((self:GetSetAmount( "Darkruned Battlegear" ) >= 4) and 1.2 or 1))
	end
	self.Calculation["Scourge Strike"] = self.Calculation["Blood Strike"]
	self.Calculation["Heart Strike"] = self.Calculation["Blood Strike"]
	self.Calculation["Obliterate"] = function( calculation, _, _, _, baseSpell )
		calculation.dmgM = calculation.dmgM * (self.HasGlyph(58671) and 1.2 or 1) * (1 + self.diseaseCount * baseSpell.bonusPercent * ((self:GetSetAmount( "Darkruned Battlegear" ) >= 4) and 1.2 or 1))
	end
	
	self.Calculation["Blood Boil"] = function( calculation, _, _, spell, baseSpell )
		if self.diseaseCount ~= 0 then
			calculation.AP = self:GetAP()
			calculation.minDam = calculation.minDam + spell.diseaseBonus + (calculation.AP * (baseSpell.BoilSpellAPBonus + 0.035))
			calculation.maxDam = calculation.maxDam + spell.diseaseBonus + (calculation.AP * (baseSpell.BoilSpellAPBonus + 0.035))
        	else            
			calculation.AP = self:GetAP()
			calculation.minDam = calculation.minDam + (calculation.AP * baseSpell.BoilSpellAPBonus)
			calculation.maxDam = calculation.maxDam + (calculation.AP * baseSpell.BoilSpellAPBonus)
		end
	end
	
	self.Calculation["Icy Touch"] = function( calculation, _, BuffTalentRanks )
		if BuffTalentRanks["Glacier Rot"] and self.diseaseCount > 0 then
			calculation.dmgM = calculation.dmgM * (1 + BuffTalentRanks["Glacier Rot"])
		end
		calculation.dotSpellDmgM = 0
		calculation.hybridDotDmg = 5 * 0.055 * self:GetAP()
	end
	
	-- TODO : Add Glyph of Howling Blast to add Frost Fever dot from Icy Touch
	self.Calculation["Howling Blast"] = function( calculation, _, BuffTalentRanks, spell )
		if BuffTalentRanks["Glacier Rot"] then
			if self.diseaseCount > 0 then
				calculation.dmgM = calculation.dmgM * (1 + BuffTalentRanks["Glacier Rot"])
			end
		end
	end
	self.Calculation["Frost Strike"]  = self.Calculation["Howling Blast"]
    
	self.Calculation["Death Coil"] = function( calculation )
		if self.HasGlyph(63333) then
			calculation.dmgM = calculation.dmgM * 1.15
		end
	end
	self.Calculation["Death and Decay"] = function( calculation )
		if self.HasGlyph(58629) then
			calculation.dmgM = calculdation.dmgM * 1.2
		end
	end
	self.Calculation["Death Strike"] = function( calculation )
		if self.HasGlyph(59336) then -- increase damage by 2% for every 2 RP, max of 25%
			local power = UnitPower("player", RUNIC_POWER)
			if power > 25 then power = 25 end
			calculation.dmgM = calculation.dmgM * (1 + power/100)
		end
	end
	self.Calculation["Plague Strike"] = function( calculation )
		if self.HasGlyph(58657) then
			calculation.dmgM = calculation.dmgM * 1.2
		end
	end
	self.Calculation["Rune Strike"] = function( calculation )
		if self.HasGlyph(58669) then
			calculation.critPerc = calculation.critPerc + 10
		end
	end
	self.Calculation["Unholy Blight"] = function( calculation )
		if self.HasGlyph(63332) then
			calculation.eDuration = calculation.eDuration + 10
		end
	end
	self.Calculation["Rune Tap"] = function( calculation, _, BuffTalentRanks )
		calculation.dmgM = UnitHealthMax("player") * 0.1 * (self.HasGlyph(59327) and 1.1 or 1) * ( 1 + (BuffTalentRanks["Improved Rune Tap"] or 0))
	end
    
	--Set Bonuses
	self.SetBonuses["Scourgeborne Battlegear"] = 
		{ 39617, 39618, 39619 , 39620 , 39621, -- T7
		40550, 40552, 40554, 40556, 40557 }  -- T7.5
	self.SetBonuses["Scourgeborne Plate"] = 
        	{ 39623, 39624, 39625, 39626, 39627,  -- T7
		40559, 40563, 40565, 40567, 40568 } -- T7.5
	self.SetBonuses["Darkruned Battlegear"] =
		{ 45340, 45341, 45342, 45343, 45344,  -- T8
		46111, 46113, 46115, 46116, 46117 } -- T8.5
	self.SetBonuses["Darkruned Plate"] =
		{ 45335, 45336, 45337, 45338, 45339,  -- T8
		46118, 46119, 46120, 46121, 46122 } -- T8.5
    
	--Set Effects
	self.SetBonuses["Scourge Strike"] = function ( calculation )
		if self:GetSetAmount( "Scourgeborne Battlegear" ) >= 2 then
			calculation.critPerc = calculation.critPerc + 5
		end
	end
	self.SetBonuses["Obliterate"] = self.SetBonuses["Scourge Strike"]
	self.SetBonuses["Death Strike"] = self.SetBonuses["Scourge Strike"]
	self.SetBonuses["Plague Strike"] = function ( calculation )
		if self:GetSetAmount( "Scourgeborne Plate" ) >= 2 then
			calculation.critPerc = calculation.critPerc + 10
		end
	end
	self.SetBonuses["Death Coil"] = function ( calculation )
		if self:GetSetAmount( "Darkruned Battlegear" ) >= 2 then
			calculation.critPerc = calculation.critPerc + 8
		end
	end
	self.SetBonuses["Frost Strike"] = self.SetBonuses["Death Coil"]
	self.SetBonuses["Rune Strike"] = function ( calculation )
		if self:GetSetAmount( "Darkruned Plate" ) >= 2 then
			calculation.dmgM = calculation.dmgM * 1.1
		end
	end
	
	--Relic Bonuses
	self.RelicSlot["Blood Strike"]      = { 39208, 90 }  -- Sigil of the Dark Rider
	self.RelicSlot["Icy Touch"]         = { 40822, 111 } -- Sigil of the Frozen Conscience
	self.RelicSlot["Heart Strike"]      = { 39208, 90 }  -- Sigil of the Dark Rider
	self.RelicSlot["Scourge Strike"]    = { 40207, 189, 40875, 91.35 } -- Sigil of Awareness, Sigil of Arthritic Binding
	self.RelicSlot["Obliterate"]        = { 40207, 336 } -- Sigil of Awareness
	self.RelicSlot["Death Strike"]      = { 40207, 315 } -- Sigil of Awareness
	self.RelicSlot["Death Coil"]        = { 45254, 380, 40867, 80 } -- Sigil of the Venegeful Heart, Sigil of the Wild Buck
	self.RelicSlot["Frost Strike"]      = { 45254, 380 } -- Sigil of the Venegeful Heart
	
	--Auras
	--Killing Machine
	--Death Chill
	self.PlayerAura[GetSpellInfo(51124)] = { Spell = { GetSpellInfo(45477), GetSpellInfo(49184), GetSpellInfo(49143) }, Value = 100, ModType = "critPerc" }
	self.PlayerAura[GetSpellInfo(49796)] = { Spell = { GetSpellInfo(45477), GetSpellInfo(49184), GetSpellInfo(49143), GetSpellInfo(49020) }, Value = 100, ModType = "critPerc" }
	
	--Frost Fever
	--Blood Plague
	--Crypt Fever (necessary for proper disease count)
	--Ebon Plague
	self.TargetAura[GetSpellInfo(55095)] = { ModType = "ActiveAura", ActiveAura = "Frost Fever" }
	self.TargetAura[GetSpellInfo(55078)] = { ModType = "ActiveAura", ActiveAura = "Blood Plague" }
	self.TargetAura[GetSpellInfo(50508)] = { ModType = "Update" }
	self.TargetAura[GetSpellInfo(51726)] = { ModType = "ActiveAura", ActiveAura = "Ebon Plague", }
	
	self.spellInfo = {
		--BLOOD
		[GetSpellInfo(45902)] = {
				["Name"] = "Blood Strike",
				[0] = { Melee = true, WeaponDamage = 0.4, bonusPercent =  0.125 },
				[1] = { 104 },
				[2] = { 118 },
				[3] = { 138.8 },
				[4] = { 164.4 },
				[5] = { 250 },
				[6] = { 305.6 },
		},
		[GetSpellInfo(48721)] = {
				["Name"] = "Blood Boil",
				[0] = { School = "Shadow", BoilSpellAPBonus = 0.06, canCrit = true },
				[1] = { 89, 107, diseaseBonus = 0, spellLevel = 58 }, -- diseaseBonus = 0 until tested
				[2] = { 116, 140, diseaseBonus = 0, spellLevel = 66 }, -- diseaseBonus = 0 until tested
				[3] = { 149, 181, diseaseBonus = 0, spellLevel = 72 }, -- diseaseBonus = 0 until tested
				[4] = { 180, 220, diseaseBonus = 95, spellLevel = 78 },
		},
		[GetSpellInfo(55050)] = {
				["Name"] = "Heart Strike",
				[0] = { Melee = true, WeaponDamage = 0.5, bonusPercent = 0.1 },
				[1] = { 125 },
				[2] = { 142 },
				[3] = { 167 },
				[4] = { 197.5 },
				[5] = { 300.5 },
				[6] = { 368 },
		},
		[GetSpellInfo(48982)] = {
			["Name"] = "Rune Tap",
			[0] = { School = "Healing", cooldown = 60, canCrit = true },
			[1] = { 1, 1 }
		},
        -- TODO : Dancing Rune Weapon; will require calculating Runic Power for duration.  Not sure how to model "does 50% of attacks the player does"
		--FROST
		[GetSpellInfo(45477)] = {
				["Name"] = "Icy Touch",
				[0] = { School = "Frost", canCrit = true, SpellAPBonus = 0.1, eDuration = 15, sTicks = 3 },
				[1] = { 127, 137, spellLevel = 55 },
				[2] = { 144, 156, spellLevel = 61 },
				[3] = { 161, 173, spellLevel = 67 },
				[4] = { 187, 203, spellLevel = 73 },
				[5] = { 227, 245, spellLevel = 78 },
		},
		[GetSpellInfo(49020)] = {
				["Name"] = "Obliterate",
				[0] = { Melee = true, WeaponDamage = 0.8, bonusPercent = 0.125 },
				[1] = { 198.4  },
				[2] = { 244  },
				[3] = { 381.6  },
				[4] = { 467.2  },
		},
		[GetSpellInfo(56815)] = {
				["Name"] = "Rune Strike",
				[0] = { Runic = 20, Melee = true, WeaponDamage = 1.5, APBonus = 0.15, NextMelee = true },
				[1] = { 0 },
		},
		[GetSpellInfo(49184)] = {
				["Name"] = "Howling Blast",
				[0] = { School = "Frost", canCrit = true, SpellAPBonus = 0.2, cooldown = 8 },
				[1] = { 198, 214, spellLevel = 60 },
				[2] = { 324, 352, spellLevel = 70 },
				[3] = { 441, 479, spellLevel = 75 },
				[4] = { 518, 562, spellLevel = 80 },
		},
		[GetSpellInfo(49143)] = {
				["Name"] = "Frost Strike",
				[0] = { School = "Frost", Runic = 40, Melee = true, WeaponDamage = 0.6 },
				[1] = { 52.2 },
				[2] = { 61.8 },
				[3] = { 69 },
				[4] = { 85.2 },
				[5] = { 120.6 },
				[6] = { 150 },
		},
		--UNHOLY
		[GetSpellInfo(52375)] = {
				["Name"] = "Death Coil",
				[0] = { Runic = 40, School = "Shadow", canCrit = true, SpellAPBonus = 0.15 },
				[1] = { 184, 184, spellLevel = 55 },
				[2] = { 208, 208, spellLevel = 62 },
				[3] = { 275, 275, spellLevel = 68 },
				[4] = { 381, 381, spellLevel = 76 },
				[5] = { 443, 443, spellLevel = 80 },
			["Secondary"] = {
				["Name"] = "Death Coil",
				[0] = { Runic = 40, School = { "Shadow", "Healing" }, canCrit = true, SpellAPBonus = 0.15 },
				[1] = { 276, 276, spellLevel = 55 },
				[2] = { 312, 312, spellLevel = 62 },
				[3] = { 412.5, 412.5, spellLevel = 68 },
				[4] = { 571.5, 571.5, spellLevel = 76 },
				[5] = { 664.5, 664.5, spellLevel = 80 },
			},
		},
		[GetSpellInfo(45462)] = {
				["Name"] = "Plague Strike",
				[0] = { Melee = true, WeaponDamage = 0.5, E_eDuration = 15, ExtraDamage = 5 * 0.055 },
				[1] = { 62.5 },
				[2] = { 75.5 },
				[3] = { 89 },
				[4] = { 108 },
				[5] = { 157 },
				[6] = { 189 },
		},
		[GetSpellInfo(49998)] = {
				["Name"] = "Death Strike",
				[0] = { Melee = true, WeaponDamage = 0.75 },
				[1] = { 84 },
				[2] = { 97.5 },
				[3] = { 123.75 },
				[4] = { 187.5 },
				[5] = { 222.75 },
		},
		[GetSpellInfo(43265)] = {
				["Name"] = "Death and Decay",
				[0] = { School = "Shadow", castTime = 10, sHits = 11, Cooldown = 30, SpellAPBonus = 0.0475 },
				[1] = { 26, 26, spellLevel = 60 },
				[2] = { 34, 34, spellLevel = 67 },
				[3] = { 49, 49, spellLevel = 73 },
				[4] = { 62, 62, spellLevel = 80 },
		},
		[GetSpellInfo(49158)] = {
				["Name"] = "Corpse Explosion",
				[0] = { Runic = 40, School = "Shadow", canCrit = true, SpellAPBonus = 0.105 },
				[1] = { 166, 166, spellLevel = 20 },
				[2] = { 192, 192, spellLevel = 60 },
				[3] = { 262, 262, spellLevel = 70 },
				[4] = { 383, 383, spellLevel = 75 },
				[5] = { 443, 443, spellLevel = 80 },
		},
		[GetSpellInfo(55090)] = {
				["Name"] = "Scourge Strike",
				[0] = { School = "Shadow", Melee = true, WeaponDamage = 0.45, bonusPercent = 0.11 },
				[1] = { 151.875 },
				[2] = { 186.75 },
				[3] = { 291.375 },
				[4] = { 357.188 },
		},
		[GetSpellInfo(49194)] = {
				["Name"] = "Unholy Blight",
				[0] = { Runic = 40, School = "Shadow", eDot = true, eDuration = 20, sTicks = 1, SpellAPBonus = 0.013 },
				[1] = { 420, 420, spellLevel = 60 },
				[2] = { 600, 600, spellLevel = 70 },
				[3] = { 800, 800, spellLevel = 75 },
				[4] = { 960, 960, spellLevel = 80 },
		},
		[GetSpellInfo(49206)] = {
				["Name"] = "Summon Gargoyle",
				[0] = { Runic = 50, School = "Nature", eDot = true, eDuration = 40, sTicks = 1, SpellAPBonus = (1/3) },
				[1] = { 51, 69 }
		},
	}
	self.talentInfo = {
		--BLOOD
		--Subversion
		--Two-Handed Weapon Specialization
		--Improved Rune Tap
		--Dark Conviction
		--Bloody Strikes
		--Improved Death Strike
		--Might of Mograine
		[GetSpellInfo(48997)] = { 	[1] = { Effect = 3, Spells = { "Blood Strike", "Heart Strike", "Obliterate" }, ModType = "critPerc", }, },
		[GetSpellInfo(55107)] = { 	[1] = { Effect = 0.02, Melee = true, Spells = "Physical", ModType = "Two-Handed Weapon Specialization" }, },
		[GetSpellInfo(48985)] = {	[1] = { Effect = (1/3), Spells = "Rune Tap", ModType = "Amount", Value = "Improved Rune Tap", },
						[2] = { Effect = -10, ModType = "cooldown", }, },
		[GetSpellInfo(48987)] = {	[1] = { Effect = 1, ModType = "critPerc" }, },
		[GetSpellInfo(48977)] = {	[1] = { Effect = 0.15, Spells = { "Blood Strike", "Heart Strike" }, },
						[2] = { Effect = 0.1, Spells = "Blood Boil", }, },
		[GetSpellInfo(62905)] = {	[1] = { Effect = 0.15, Spells = "Death Strike" }, 
						[2] = { Effect = 3, Spells = "Death Strike", ModType = "critPerc" }, },
		[GetSpellInfo(49023)] = {	[1] = { Effect = 0.15, Spells = { "Blood Boil", "Blood Strike", "Death Strike", "Heart Strike" }, ModType = "critM", }, },
		--FROST
		--Improved Icy Touch
		--Glacier Rot
		--Black Ice
		--Nerves of Cold Steel
		--Annihilation
		--Rime
		--Blood of the North
		--Guile of Gorefiend
		--Tundra Stalker
		[GetSpellInfo(49175)] = {	[1] = { Effect = 0.05, Spells = "Icy Touch" }, },
		[GetSpellInfo(49471)] = {	[1] = { Effect = { 0.07, 0.13, 0.2 }, Spells = { "Icy Touch", "Howling Blast", "Frost Strike" }, ModType = "Amount", Value = "Glacier Rot" }, },
		[GetSpellInfo(49140)] = {	[1] = { Effect = 0.02, Spells = { "Frost", "Shadow" }, }, },
		[GetSpellInfo(49226)] = {	[1] = { Effect = 0.05, Spells = "All", Melee = true, ModType = "offHdmgM", Multiply = true  }, NoManual = true },
		[GetSpellInfo(51468)] = {	[1] = { Effect = 1, Spells = "All", Melee = true, Specials = true, ModType = "critPerc" }, },
		[GetSpellInfo(49188)] = {	[1] = { Effect = 5, Spells = { "Icy Touch", "Obliterate" }, ModType = "critPerc" }, },
		[GetSpellInfo(54639)] = {	[1] = { Effect = 0.03, Spells = { "Blood Strike", "Frost Strike" } }, },
		[GetSpellInfo(50187)] = {	[1] = { Effect = 0.15, Spells = { "Blood Strike", "Frost Strike", "Howling Blast", "Obliterate" }, ModType = "critM", }, },
		[GetSpellInfo(49202)] = {	[1] = { Effect = 0.03, Spells = "All", ModType = "Amount", Value = "Tundra Stalker" }, },
		--UNHOLY
		--Vicious Strikes
		--Virulence
		--Morbidity
		--Outbreak
		--Necrosis
		--Impurity
		--Ebon Plaguebringer
		--Rage of Rivendare
		--Epidemic
		[GetSpellInfo(51745)] = {	[1] = { Effect = 3, Spells = { "Plague Strike", "Scourge Strike" }, ModType = "critPerc" },
						[2] = { Effect = 0.15, Spells = { "Plague Strike", "Scourge Strike" }, ModType = "critM" }, },
		[GetSpellInfo(48962)] = {	[1] = { Effect = 1, ModType = "hitPerc" }, },
		[GetSpellInfo(48963)] = {	[1] = { Effect = 0.05, Spells = "Death Coil" },
						[2] = { Effect = -5, Spells = "Death and Decay", ModType = "cooldown" }, },
		[GetSpellInfo(49013)] = {	[1] = { Effect = 0.1, Spells = { "Plague Strike" }, },
						[2] = { Effect = {0.07, 0.13, 0.2}, Spells = "Scourge Strike" }, },
		[GetSpellInfo(51459)] = {	[1] = { Effect = 0.04, Spells = "Attack", ModType = "Amount", Value = "Necrosis" }, },
		[GetSpellInfo(49220)] = {	[1] = { Effect = 0.04, Spells = "All", ModType = "Amount", Value = "Impurity" }, },
		[GetSpellInfo(51099)] = {	[1] = { Effect = { 0.04, 0.09, 0.13 }, Spells = { "Shadow", "Frost" }, ModType = "Amount", Value = "Ebon Plaguebringer" }, },
		[GetSpellInfo(50117)] = {	[1] = { Effect = 0.02, Spells = "All", ModType = "Amount", Value = "Rage of Rivendare" }, },
		[GetSpellInfo(49562)] = {	[1] = { Effect = 3, Spells = "Icy Touch", ModType = "eDuration" }, 
						[2] = { Effect = 3, Spells = "Plague Strike", ModType = "E_eDuration" }, },
	}
end